using System;
using System.Collections.Generic;
using System.Text;
using System.IO;
using System.IO.Compression;

namespace Toolkit {
	/// <summary>
	/// zipt@C̍쐬
	/// </summary>
	public class ZipWriter : IDisposable {
		/// <summary>
		/// ݁B
		/// </summary>
		BinaryWriter writer;

		/// <summary>
		/// t@CƃfBNgBǉꂽɁB
		/// fBNg؂/B
		/// /ȂfBNgB
		/// </summary>
		List<string> entry = new List<string>();

		public ZipWriter(string fileName) : this(File.Create(fileName)) {
		}

		public ZipWriter(Stream stream) : this(new BinaryWriter(stream)) {
		}

		public ZipWriter(BinaryWriter writer) {
			this.writer = writer;
		}

		/// <summary>
		/// fBNg̍쐬
		/// </summary>
		/// <param name="dir">݂fBNg</param>
		/// <param name="innerName">ɓł̃fBNg</param>
		public void AddDirectory(string dir, string innerName) {
			innerName = innerName.Replace('\\', '/');
			if (!innerName.EndsWith("/")) {
				innerName += '/';
			}
			/*
				/// t@Cwb_̂P
				struct SPK34 {
					dword dwSignature;              // 0x04034b50
					word wExtractVersion;           // 0x000aH 0x0014H
					word wGeneralFlags;             // 0? 0x0002?
					word wCompressionMethod;        // 0? 0x0008?
					word wUpdateTime;
					word wUpdateDate;               // ŏIXVFFTIME
					dword dwOriginalFileCrc;
					dword dwCompressSize;
					dword dwOriginalFileSize;
					word wFileNameLength;           // t@C̒
					word wExtensionFieldLength;     // gtB[hTCY
				 // vector<char> strFileName;
				 // vector<byte> abyExtensionField;
				};
			*/
			writer.Write((UInt32)0x04034b50u);
			writer.Write((UInt16)0x000a);
			writer.Write((UInt16)0x0000);
			writer.Write((UInt16)0x0000);
			System.Diagnostics.Debug.Fail("I");
		}

		/// <summary>
		/// t@C̒ǉ
		/// </summary>
		/// <param name="file">݂t@C</param>
		/// <param name="innerName">ɓł̃t@C</param>
		public void AddFile(string file, string innerName) {
			innerName = innerName.Replace('\\', '/');
			/*
				/// t@Cwb_̂P
				struct SPK34 {
					dword dwSignature;              // 0x04034b50
					word wExtractVersion;           // 0x000aH 0x0014H
					word wGeneralFlags;             // 0? 0x0002?
					word wCompressionMethod;        // 0? 0x0008?
					word wUpdateTime;
					word wUpdateDate;               // ŏIXVFFTIME
					dword dwOriginalFileCrc;
					dword dwCompressSize;
					dword dwOriginalFileSize;
					word wFileNameLength;           // t@C̒
					word wExtensionFieldLength;     // gtB[hTCY
				 // vector<char> strFileName;
				 // vector<byte> abyExtensionField;
				};
			*/
			writer.Write((UInt32)0x04034b50u);
			writer.Write((UInt16)0x0014);
			writer.Write((UInt16)0x0002);
			writer.Write((UInt16)0x0008);
			System.Diagnostics.Debug.Fail("I");
		}

		/// <summary>
		/// nB
		/// tb_݂̏˂̂ŕKĂԂׂB
		/// </summary>
		public void Dispose() {
			/*
				/// t@Cwb_̂Q
				struct SPK12 {
					dword dwSignature;              // 0x02014b50
					word wVersionMadeBy;
					word wExtractVersion;
					word wGeneralFlags;
					word wCompressionMethod;
					word wUpdateTime;
					word wUpdateDate;               // ŏIXVFFTIME
					dword dwOriginalFileCrc;
					dword dwCompressSize;
					dword dwOriginalFileSize;
					word wFileNameLength;           // t@C̒
					word wExtensionFieldLength;     // gtB[hTCY
					word wCommentLength;            // Rg̒
					word wDiskNumber;               // fBXNio[H
					word wInternalFileAttributes;   // ̂P
					dword dwExternalFileAttributes; // ̂Q
					dword dwLocalHeaderOffset;
				 // vector<char> strFileName;
				 // vector<byte> abyExtensionField;
				 // vector<char> strComment;
				};
				/// tb_
				struct SPK56 {
					dword dwSignature;              // 0x06054b50
					word wDiskNumber;               // 0?
					word wDirectoryNumber;          // 0?
					word wTotalDiskNumber;          // t@CH
					word wTotalNumber;              // t@CH
					dword dwDirectorySize;          // PK12̑Ŝ̃TCYH
					dword dwOffsetDiskNum;          // PK12JnItZbgH
					word wCommentLength;            // Rg̒
				 // vector<char> strComment;        // I[\0͖
				};
			 */
			System.Diagnostics.Debug.Fail("I");

			writer.Close();
		}
	}
}
