﻿using System;
using System.Collections.Generic;
using System.Text;

namespace ぱすわど {
	[Serializable]
	public class Config : Toolkit.Serializable {
		public byte[] Data = null;
		public string Hash = "";
		public bool MakePassViewPass = false;
		public int MakePassLen = 10;
		public bool MakePassLC = true;
		public bool MakePassUC = true;
		public bool MakePassNum = true;
		public bool MakePassOther = false;
		public string MakePassOtherChars = "_@-=~#$!";

		public Toolkit.Updater.Data.UpdateConfig UpdateConfig = new Toolkit.Updater.Data.UpdateConfig();

		#region Serialize/Deserialize

		/// <summary>
		/// 書き込み
		/// </summary>
		public void Serialize() {
			Serialize(".cfg");
		}

		/// <summary>
		/// 読み込み
		/// </summary>
		public static Config Deserialize() {
			try {
				return Deserialize<Config>(".cfg");
			} catch {
				return new Config();
			}
		}

		#endregion
	}
}
