using System;
using System.Collections.Generic;
using System.Text;

namespace Toolkit {
	/// <summary>
	/// ListɂDictionaryB
	/// </summary>
	/// <typeparam name="TKey"></typeparam>
	/// <typeparam name="TValue"></typeparam>
	class ListDictionary<TKey, TValue> : IDictionary<TKey, TValue> where TKey : IComparable<TKey> {
		List<KeyValuePair<TKey, TValue>> list
			= new List<KeyValuePair<TKey, TValue>>();

		#region IDictionary<TKey,TValue> o

		public void Add(TKey key, TValue value) {
			for (int i = 0; i < list.Count; i++) {
				int cmp = list[i].Key.CompareTo(key);
				if (cmp < 0) {
				} else if (0 < cmp) {
					list.Insert(i, new KeyValuePair<TKey, TValue>(key, value));
					return;
				} else {
					return; // TODO: ?
				}
			}
			list.Add(new KeyValuePair<TKey,TValue>(key, value));
		}

		public bool ContainsKey(TKey key) {
			return list.Exists(delegate(KeyValuePair<TKey, TValue> p) {
				return p.Key.Equals(key);
			});
		}

		public ICollection<TKey> Keys {
			get { throw new Exception("The method or operation is not implemented."); }
		}

		public bool Remove(TKey key) {
			throw new Exception("The method or operation is not implemented.");
		}

		public bool TryGetValue(TKey key, out TValue value) {
			throw new Exception("The method or operation is not implemented.");
		}

		public ICollection<TValue> Values {
			get { throw new Exception("The method or operation is not implemented."); }
		}

		public TValue this[TKey key] {
			get {
				throw new Exception("The method or operation is not implemented.");
			}
			set {
				throw new Exception("The method or operation is not implemented.");
			}
		}

		#endregion

		#region ICollection<KeyValuePair<TKey,TValue>> o

		public void Add(KeyValuePair<TKey, TValue> item) {
			Add(item.Key, item.Value);
		}

		public void Clear() {
			list.Clear();
		}

		public bool Contains(KeyValuePair<TKey, TValue> item) {
			return list.Contains(item);
		}

		public void CopyTo(KeyValuePair<TKey, TValue>[] array, int arrayIndex) {
			list.CopyTo(array, arrayIndex);

		}

		public int Count {
			get { return list.Count; }
		}

		public bool IsReadOnly {
			get { return false; }
		}

		public bool Remove(KeyValuePair<TKey, TValue> item) {
			return list.Remove(item);
		}

		#endregion

		#region IEnumerable<KeyValuePair<TKey,TValue>> o

		public IEnumerator<KeyValuePair<TKey, TValue>> GetEnumerator() {
			return list.GetEnumerator();
		}

		#endregion

		#region IEnumerable o

		System.Collections.IEnumerator System.Collections.IEnumerable.GetEnumerator() {
			return list.GetEnumerator();
		}

		#endregion
	}
}
