using System;
using System.Collections.Generic;
using System.Text;
using System.IO;

namespace Toolkit.Net {
	/// <summary>
	/// TCPƂ֌W̃[eBeB
	/// </summary>
	public static class Utility {
		/// <summary>
		/// M
		/// </summary>
		public static void Send(Stream stream, string str) {
			byte[] bytes = Encoding.Default.GetBytes(str);
			stream.Write(bytes, 0, bytes.Length);
			stream.Flush();
			System.Diagnostics.Debug.WriteLine("----- Send -----");
			System.Diagnostics.Debug.WriteLine(str);
		}

		/// <summary>
		/// M
		/// </summary>
		public static string Recv(Stream stream) {
			return RecvToCRLF(stream, Encoding.Default);
		}

		/// <summary>
		/// M
		/// </summary>
		public static string RecvToCRLF(Stream stream, Encoding encoding) {
			StringBuilder result = new StringBuilder();
			byte[] buffer = new byte[0x10]; // ܂fJƃoOɋCt񎖂邩Ȃ̂ŁBB
			while (true) {
				int len = stream.Read(buffer, 0, buffer.Length);
				result.Append(encoding.GetString(buffer, 0, len));
				// I[\r\nIƌȂB(cKȁc(L`))
				int pos = Math.Max(result.Length - 2, 0);
				if (result.ToString(pos, result.Length - pos) == "\r\n") break;
			}
			System.Diagnostics.Debug.WriteLine("----- Recv -----");
			System.Diagnostics.Debug.WriteLine(result);
			return result.ToString();
		}

		/// <summary>
		/// d폜XgԂ
		/// </summary>
		public static List<T> Unique<T>(IList<T> list) {
			List<T> result = new List<T>();
			for (int i = 0; i < list.Count; i++) {
				if (!result.Contains(list[i])) {
					result.Add(list[i]);
				}
			}
			return result;
		}
	}
}
