using System;
using System.Collections.Generic;
using System.Text;
using System.Threading;

namespace Toolkit.Time
{
	/// <summary>
	/// w莞ԂɃR[obNB
	/// o邾ׂȂ悤ɂĂ݂̂́Ax͔B
	/// </summary>
	public class RunAt
	{
		public delegate void RunDelegate();

		RunDelegate run = null;
		DateTime at;
		bool changed = false;
		Thread thread;

		public RunAt() {
		}
		public RunAt(RunDelegate run) {
			this.run = run;
		}

		/// <summary>
		/// Ăяodelegate
		/// </summary>
		public RunDelegate Run {
			get { return run; }
			set { run = value; }
		}

		/// <summary>
		/// Ăяo鎞ԁBZbgƓJnB
		/// </summary>
		public DateTime At {
			set {
				lock (run) {
					at = value;
					changed = true;
				}
				if (thread != null) {
					thread.Abort();
					thread.Join();
				}
				thread = new Thread(OnThread);
				thread.Start();
			}
			get {
				return at;
			}
		}

		private void OnThread() {
			lock (run) {
				changed = false;
			}
			Thread.Sleep(at - DateTime.Now);
			lock (run) {
				if (changed) {
					return;
				}
			}
			run();
		}
	}
}
