﻿using System;
using System.Collections.Generic;
using System.Text;
using System.Drawing;

namespace ぱすわど {
	public class Data : Toolkit.Serializable {
		public Point WindowPos = new Point(128, 256);
		public Size WindowSize = new Size(640, 480);
		public int[] ColmunWidths = { 100, 100, 100, 100, 100 };
		public int TreeWidth = 155;

		public Toolkit.Updater.Data.UpdateRecord UpdateRecord = new Toolkit.Updater.Data.UpdateRecord();

		#region Serialize/Deserialize

		/// <summary>
		/// 書き込み
		/// </summary>
		public void Serialize() {
			Serialize(".dat");
		}

		/// <summary>
		/// 読み込み
		/// </summary>
		public static Data Deserialize() {
			try {
				return Deserialize<Data>(".dat");
			} catch {
				return new Data();
			}
		}

		#endregion
	}
}
