﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;

namespace ぱすわど {
	public partial class SetPassForm : Form {
		ConfigManager configManager;

		public SetPassForm(ConfigManager configManager) {
			InitializeComponent();

			this.configManager = configManager;
		}

		private void buttonOk_Click(object sender, EventArgs e) {
			if (textBox1.Text != configManager.MasterPass) {
				MessageBox.Show(this, "マスターパスワードが一致しませんでした", "エラー");
				DialogResult = DialogResult.None;
			} else if (textBox2.Text != textBox3.Text) {
				MessageBox.Show(this, "確認入力が一致しませんでした", "エラー");
				DialogResult = DialogResult.None;
			} else {
				// 変更成功！
				configManager.MasterPass = textBox2.Text;
				System.Diagnostics.Debug.Assert(DialogResult == DialogResult.OK); // 既に設定済みのはず
			}
		}
	}
}